#include <bits/stdc++.h>
  
#define int long long
  
using namespace std;
 
int ans = 0;
 
void rec(int h, int w, int k) {
	ans += h * w * k;
	if(h != 1 || w != 1) {
		if(h % 2 == w % 2) {		
			if(h > w) {
				if(h % 2) {
					rec(h - 1, w, k);
					rec(1, w, k);
				} else {
					rec(h / 2, w, k * 2);
				}
			} else {
				if(w % 2) {
					rec(h, w - 1, k);
					rec(h, 1, k);
				} else {
					rec(h, w / 2, k * 2);
				}
			}
		} else {
			if(h % 2) {
				rec(h, w / 2, k * 2);
			} else {
				rec(h / 2, w, k * 2);
			}
		}
	}
}

main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int h, w;
	cin >> h >> w;
	rec(h, w, 1);
	cout << ans;
}
